open Gny;;

module Gny_prime_map :
  sig
    type key = Gny.gny_prime
    type 'a t
    val empty : 'a t
    val add : key -> 'a -> 'a t -> 'a t
    val find : key -> 'a t -> 'a
    val remove : key -> 'a t -> 'a t
    val iter : (key -> 'a -> unit) -> 'a t -> unit
    val fold : (key -> 'a -> 'b -> 'b) -> 'a t -> 'b -> 'b
  end

val in_pool : proof Gny_prime_map.t -> Gny.gny_prime -> proof
val apply_rules : proof Gny_prime_map.t -> proof list


